import FileButton from '@/components/FileViewRedirectButton/FileButton'
import type { CustomInjectDetails } from '@inject/graphql/fragments/CustomInjectDetails.generated'
import { forwardRef } from 'react'

interface CustomInjectContentProps {
  details: CustomInjectDetails
  teamId: string
  exerciseId: string
  inInstructor: boolean
  allowFileRedirect: boolean
}

// eslint-disable-next-line react/display-name
const CustomInjectContent = forwardRef<
  HTMLDivElement,
  CustomInjectContentProps
>(({ details, teamId, exerciseId, inInstructor, allowFileRedirect }, ref) => (
  <>
    <div
      dangerouslySetInnerHTML={{
        __html: details.content.rendered,
      }}
      ref={ref}
    />
    {details.content.fileInfo && (
      <div
        style={{
          marginTop: details.content.rendered ? '0.5rem' : undefined,
        }}
      >
        <FileButton
          teamId={teamId}
          fileInfo={details.content.fileInfo}
          exerciseId={exerciseId}
          inInstructor={inInstructor}
          allowRedirect={allowFileRedirect}
        />
      </div>
    )}
  </>
))

export default CustomInjectContent
