import FileButton from '@/components/FileViewRedirectButton/FileButton'
import type { EmailDetails } from '@inject/graphql/fragments/EmailDetails.generated'
import { forwardRef } from 'react'

interface EmailContentProps {
  details: EmailDetails
  teamId: string
  exerciseId: string
  inInstructor: boolean
  allowFileRedirect: boolean
}

// eslint-disable-next-line react/display-name
const EmailContent = forwardRef<HTMLDivElement, EmailContentProps>(
  ({ details, teamId, exerciseId, inInstructor, allowFileRedirect }, ref) => (
    <>
      <div
        dangerouslySetInnerHTML={{
          __html: details.content.rendered,
        }}
        ref={ref}
      />
      {details.content.fileInfo && (
        <div
          style={{
            marginTop: details.content.rendered ? '0.5rem' : undefined,
          }}
        >
          <FileButton
            teamId={teamId}
            fileInfo={details.content.fileInfo}
            exerciseId={exerciseId}
            inInstructor={inInstructor}
            allowRedirect={allowFileRedirect}
          />
        </div>
      )}
    </>
  )
)

export default EmailContent
