import { makeVar, useReactiveVar } from '@inject/graphql/client/reactive'

const key = 'useExperimentalV2'
const initialSettings: boolean = localStorage.getItem(key) === 'true'

export const experimentalV2 = makeVar<boolean>(initialSettings)
export const useExperimentalV2 = () => useReactiveVar(experimentalV2)

function change(value: boolean) {
  localStorage.setItem(key, value.toString())
}

experimentalV2.onNextChange(function onNext() {
  change(experimentalV2())
  experimentalV2.onNextChange(onNext)
})
