import { makeVar, useReactiveVar } from '@inject/graphql/client/reactive'

const key = 'useRelativeTime'
const initialSettings: boolean = localStorage.getItem(key) === 'true'

export const relativeTime = makeVar<boolean>(initialSettings)
export const useRelativeTime = () => useReactiveVar(relativeTime)

function change(value: boolean) {
  localStorage.setItem(key, value.toString())
}

relativeTime.onNextChange(function onNext() {
  change(relativeTime())
  relativeTime.onNextChange(onNext)
})
