import { InputGroup, Label, TextArea } from '@blueprintjs/core'
import { memo, type FC } from 'react'
import EmailAddressSelector from '../EmailAddressSelector'

interface EmailTemplateFormProps {
  context: string
  onContextChange: (value: string) => void
  content: string
  onContentChange: (value: string) => void
  emailAddressId: number
  onEmailAddressIdChange: (value: number) => void
}

const EmailTemplateForm: FC<EmailTemplateFormProps> = ({
  context,
  onContextChange,
  content,
  onContentChange,
  emailAddressId,
  onEmailAddressIdChange,
}) => (
  <div>
    <EmailAddressSelector
      emailAddressId={emailAddressId}
      onChange={id => onEmailAddressIdChange(id)}
    />
    <Label>
      Context
      <InputGroup
        placeholder='Input text'
        value={context}
        onChange={e => onContextChange(e.target.value)}
      />
    </Label>
    <Label>
      Content
      <TextArea
        value={content}
        style={{
          width: '100%',
          height: '10rem',
          resize: 'none',
          overflowY: 'auto',
        }}
        placeholder='Input text'
        onChange={e => onContentChange(e.target.value)}
      />
    </Label>
  </div>
)

export default memo(EmailTemplateForm)
