import useEditorStorage from '@/editor/useEditorStorage'
import { InputGroup, Label, Section, SectionCard } from '@blueprintjs/core'
import { memo, useEffect, useState } from 'react'

const InfoChannelForm = () => {
  const [config, setConfig] = useEditorStorage()
  const [infoChannelName, setInfoChannelName] = useState(
    config?.infoChannelName || ''
  )

  useEffect(() => {
    setConfig({
      ...config,
      infoChannelName,
    })
  }, [infoChannelName])

  return (
    <Section title='Information' style={{ marginBottom: '1rem' }}>
      <SectionCard>
        <Label>
          Custom information channel name
          <InputGroup
            placeholder='Input text'
            value={infoChannelName}
            onChange={e => setInfoChannelName(e.target.value)}
          />
        </Label>
      </SectionCard>
    </Section>
  )
}

export default memo(InfoChannelForm)
