import useEditorStorage from '@/editor/useEditorStorage'
import { InputGroup, Label, Section, SectionCard } from '@blueprintjs/core'
import { memo, useEffect, useState } from 'react'

const ToolChannelForm = () => {
  const [config, setConfig] = useEditorStorage()
  const [toolChannelName, setToolChannelName] = useState(
    config?.toolChannelName || ''
  )

  useEffect(() => {
    setConfig({
      ...config,
      toolChannelName,
    })
  }, [toolChannelName])

  return (
    <Section title='Tools' style={{ marginBottom: '1rem' }}>
      <SectionCard>
        <Label>
          Custom tool channel name
          <InputGroup
            placeholder='Input text'
            value={toolChannelName}
            onChange={e => setToolChannelName(e.target.value)}
          />
        </Label>
      </SectionCard>
    </Section>
  )
}

export default memo(ToolChannelForm)
