import { db } from '@/editor/indexeddb/db'
import type { QuestionnaireQuestion } from '@/editor/indexeddb/types'
import { CardList } from '@blueprintjs/core'
import { useLiveQuery } from 'dexie-react-hooks'
import type { FC } from 'react'
import { memo } from 'react'
import QuestionnaireQuestionItem from './QuestionnaireQuestion'

interface QuestionnaireQuestionsProps {
  questionnaireId: number
}

const QuestionnaireQuestions: FC<QuestionnaireQuestionsProps> = ({
  questionnaireId,
}) => {
  const questionnaireQuestions = useLiveQuery(
    () => db.questionnaireQuestions.where({ questionnaireId }).toArray(),
    [questionnaireId],
    []
  )

  return (
    <>
      <p>Questions</p>
      <CardList>
        {questionnaireQuestions?.map((question: QuestionnaireQuestion) => (
          <QuestionnaireQuestionItem
            key={question.id}
            questionnaireQuestion={question}
          />
        ))}
      </CardList>
    </>
  )
}

export default memo(QuestionnaireQuestions)
