import { db } from '@/editor/indexeddb/db'
import type { ToolResponse } from '@/editor/indexeddb/types'
import { CardList } from '@blueprintjs/core'
import { useLiveQuery } from 'dexie-react-hooks'
import type { FC } from 'react'
import { memo } from 'react'
import ToolResponseItem from './ToolResponse'

interface ToolResponsesProps {
  toolId: number
}

const ToolResponses: FC<ToolResponsesProps> = ({ toolId }) => {
  const toolResponses = useLiveQuery(
    () => db.toolResponses.where({ toolId: Number(toolId) }).toArray(),
    [toolId],
    []
  )

  return (
    <CardList>
      {toolResponses?.map((toolResponse: ToolResponse) => (
        <ToolResponseItem key={toolResponse.id} toolResponse={toolResponse} />
      ))}
    </CardList>
  )
}

export default memo(ToolResponses)
