import GitVersion from '@/components/GitVersion'
import DefinitionManager from '@/exercisepanel/DefinitionManager'
import ExerciseManager from '@/exercisepanel/ExerciseManager'
import ExportImport from '@/exercisepanel/ExportImport'
import { Modals } from '@generouted/react-router'
import useAuthIdentity from '@inject/graphql/auth'

const ExercisePanel = () => {
  const { isSuperuser } = useAuthIdentity()

  return (
    <>
      {isSuperuser && <ExportImport />}
      <DefinitionManager />
      <ExerciseManager />
      <GitVersion />

      {/* needed for the DefinitionManager, as it uses a modal path */}
      <Modals />
    </>
  )
}

export default ExercisePanel
