import EditorPage from '@/editor/EditorPage'
import EmailAddressForm from '@/editor/EmailAddressForm'
import EmailAddresses from '@/editor/EmailAddresses'
import { memo } from 'react'

const EmailAddressesPage = () => (
  <EditorPage
    title='Define email addresses'
    description='Description.'
    prevPath='/editor/create/other'
    nextVisible={false}
  >
    <EmailAddresses />
    <EmailAddressForm
      buttonProps={{
        minimal: true,
        text: 'Add email address',
        alignText: 'left',
        icon: 'plus',
        style: { padding: '1rem', width: '100%' },
      }}
    />
  </EditorPage>
)

export default memo(EmailAddressesPage)
