import EditorPage from '@/editor/EditorPage'
import { useNavigate } from '@/router'
import { Card, CardList } from '@blueprintjs/core'
import { memo } from 'react'

const OtherPage = () => {
  const nav = useNavigate()

  return (
    <EditorPage
      title='Define other information'
      description='Add new tools and email addresses to your exercise.'
      prevPath='/editor/create/inject-specification'
      nextPath='/editor/create/final-information'
    >
      <CardList>
        <Card interactive onClick={() => nav(`/editor/create/tools`)}>
          Tools
        </Card>
        <Card interactive onClick={() => nav(`/editor/create/emails`)}>
          Email addresses
        </Card>
      </CardList>
    </EditorPage>
  )
}

export default memo(OtherPage)
