/* eslint-disable react/prop-types */
import { Text } from '@blueprintjs/core'
import { type DocRenderer } from '@cyntler/react-doc-viewer'
import { css } from '@emotion/css'
import { textFileLoader } from '../loaders'

const container = css`
  display: flex;
  flex-direction: column;
  flex: 1;
  overflow-y: auto;
  gap: 1rem;
  padding-left: 0.2rem;
  margin-left: 1rem;
  white-space: 'pre-line';
`

const TXTRenderer: DocRenderer = ({ mainState: { currentDocument } }) => {
  const text = currentDocument?.fileData?.toString()

  return (
    <div id='txt-renderer' className={container}>
      <Text style={{ whiteSpace: 'pre-line', fontFamily: 'monospace' }}>
        {text}
      </Text>
    </div>
  )
}

export default TXTRenderer

TXTRenderer.fileTypes = ['txt', 'text/plain']
TXTRenderer.weight = 0
TXTRenderer.fileLoader = textFileLoader
